<?php

namespace FiloBlu\Paymentscapture\Model\Config\Backend;


class Serialized extends \Magento\Framework\App\Config\Value
{

    /**
     * @return \Magento\Framework\App\Config\Value|void
     */
    protected function _afterLoad()
    {
        if (!is_array($this->getValue())) {
            $value = $this->getValue();
            if (empty($value)) {
                $this->setValue(false);
            } else {
                if (class_exists(\Magento\Framework\Serialize\SerializerInterface::class)) {
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $serializer = $objectManager->create(\Magento\Framework\Serialize\SerializerInterface::class);
                    $this->setValue($serializer->unserialize($value));
                } else {
                    $this->setValue(\unserialize($this->getValue()));
                }
            }
        }
    }

    /**
     * @return \Magento\Framework\App\Config\Value
     */
    public function beforeSave()
    {
        if (is_array($this->getValue())) {
            if (class_exists(\Magento\Framework\Serialize\SerializerInterface::class)) {
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $serializer = $objectManager->create(\Magento\Framework\Serialize\SerializerInterface::class);
                $this->setValue($serializer->serialize($value));
            } else {
                $this->setValue(\serialize($this->getValue()));
            }
        }
        return parent::beforeSave();
    }


}
