<?php

/**
 * Backend for serialized array data
 * Makes saved data readable on both Magento 2.1 and Magento 2.2
 *
 */
namespace FiloBlu\Paymentscapture\Model\Config\Backend\Serialized;


class ArraySerialized extends \FiloBlu\Paymentscapture\Model\Config\Backend\Serialized
{
    /**
     * Unset array element with '__empty' key
     *
     * @return $this
     */
    public function beforeSave()
    {
        $value = $this->getValue();
        if (is_array($value)) {
            unset($value['__empty']);
        }
        $this->setValue($value);
        return parent::beforeSave();
    }
}
